<?php
////////////////////////////////////////////////////////////////////////////////
//   Copyright (C) ReloadCMS Development Team                                 //
//   http://reloadcms.com                                                     //
//   This product released under GNU General Public License v2                //
////////////////////////////////////////////////////////////////////////////////

	function showErrors	($errors,$message = '') {
		if(count($errors)>0) {
		if (!empty($message)) $message = ' ('.$message.')';
			$message = __('Error occurred').$message.': <br/>';
			foreach ($Errors as $value)	$message .= $value.'<br/>';
			rcms_showAdminMessage ($message);	
		} else return '';
	}

	function makeGoodPath($path){
		if (strlen($path)>0){
			$path = str_replace('\\', '/', $path);
			$partPath = explode('/', $path);
			$els = count($partPath)-1;
			for ($i = $els; $i>=0; $i--){
				if ($partPath[$i] == '.'){
                }
				elseif ($partPath[$i] == '..'){
                    $i--;
                }
				elseif (($partPath[$i] == '') and ($i!=$els) and ($i!=0)){
                }	else
					$result = $partPath[$i].($i!=$els ? '/'.$result : '');
			}
		} else $result = '';
		return $result;
	}

	function convertDir($file_array){
		global $system;
		$result = true;
		$errors = array();
		$array_noconvert = array('jpg','png','gif','jpeg','js','css','htaccess','ico','htaccess','zip','tar','gz','tgz','rar');

		for ($i = 0; $i<count($file_array); $i++){
		
			$filename = $file_array[$i];

			if (strlen($filename)<=0)
				continue;

			if (!file_exists($filename)){
				$errors[] = __('No file').' '.$filename;
				continue;
			}
			
		if (strlen($filename)<=0){
			$errors[] = __('Filename').' '.__('is incorrect');;
			return false;
		}

		$filename = str_replace('\\', '/', $filename);

		$filename = makeGoodPath($filename);

		if (is_file($filename)){
		$path_info = pathinfo($filename); 
		if (!empty($path_info['extension'])) $ext =  $path_info['extension']; else $ext = ''; 
			if (in_array($ext, $array_noconvert)) return true;
				$map = str_replace('windows-', 'CP',$system->config['encoding']);
			if (is_file(ADMIN_PATH.'libs/utf_maps/'.$map.'.MAP')) {
				$data = file_get_contents($filename);
				$utfConverter = new utf8($map);
				$data = $utfConverter->strToUtf8($data);
				file_write_contents ($filename,$data);
				rcms_showAdminMessage ($filename.' write!<br/>');			
			} else rcms_showAdminMessage (ADMIN_PATH.'libs/utf_maps/'.$map.'.MAP'.' not found');
		}	

			if (@is_dir($filename)){
				if (!($handle = opendir($filename))){
					$this->errors[] = __('Error').': '.__('Directory ').$filename.__('is not readable');
					continue;
				}

				while (false !== ($dir = readdir($handle))){
					if ($dir!='.' && $dir!='..'){
						$file_array_tmp = array();
						if ($filename != '.')
							$file_array_tmp[] = $filename.'/'.$dir;
						else
							$file_array_tmp[] = $dir;
						$result = convertDir($file_array_tmp);
					}
				}
				unset($file_array_tmp);
				unset($dir);
				unset($handle);
			}
		}
		if 		(empty($errors)) return $result;
		else {showErrors($errors); return false;}
	}
////////////////////////////////////////////////////////////////////////////////
// Convert windows CP encoding to UTF-8										  //
////////////////////////////////////////////////////////////////////////////////

//Initialization
if(!empty($_POST['start'])){
rcms_loadAdminLib('utf8');
$time = explode(" ",microtime());
$time = $time[1];
$totaltime = 0;
$step = 0;

//step: save in archive ./language, ./content and ./config
if (!empty($_POST['backupit'])) {
rcms_loadAdminLib('archive');
$step++;
rcms_showAdminMessage ('<b>' . __('Step '). $step .': backup </b>');
$result = '';
	if(!empty($_POST['gzip'])) $suffix = '.gz';
	else $suffix = '';
    $bkupfilename = BACKUP_PATH . 'converter_utf8_'.date('d.m.Y_H-i-s').'.tar' . $suffix;
$backup = new archiveTar();
$backup->archive_name = $bkupfilename;
if(!empty($_POST['gzip'])) $backup->isGzipped = true; 
else $backup->isGzipped = false;
$success = $backup->createArchive(array(LANG_PATH,DATA_PATH,CONFIG_PATH));
if (!$success) $Errors = $backup->showErrors(basename($bkupfilename));
		if(!empty($Errors)) $result .= $Errors;
		else  $result .= __('Backup complete') . ' (' . basename($bkupfilename) . ') <a href="admin.php?show=module&id=general.backup">' . __('Restore') . '</a>';
		rcms_showAdminMessage ($result);
    $steptime = explode(" ",microtime());
    $steptime = $steptime[1];
	rcms_showAdminMessage ('Step ' . $step . __(' done in ').number_format($steptime-$time).' secs');
	$totaltime += $steptime;
	$time = $steptime;
}

//step: convert langs
if (!empty($_POST['langs'])){
$step++;
rcms_showAdminMessage ('<b>' . __('Step '). $step .': convert langs </b>');
$langpaths = $system->data['langpath'];
foreach ($langpaths as $language=>$path){
$lngdata = file($path.'langid.txt');
$encoding = preg_replace("/[\n\r]+/", '', $lngdata[2]);
$windows = strpos($encoding, 'windows-');
if ($windows === 'false') {
rcms_showAdminMessage($language . ': <font color="red">'.__('Error occurred').'</font>');
exit;}
$map = str_replace('windows-', 'CP',$encoding);
$lngdir = rcms_scandir($path);
rcms_showAdminMessage ('<b>'.$language.': '.$encoding.':</b><br/>');
	foreach ($lngdir as $langfile){
	if (($langfile == 'langid.txt')&& is_file(ADMIN_PATH.'libs/utf_maps/'.$map.'.MAP')) {
	file_write_contents ($path . $langfile,$lngdata[0]."\r".$lngdata[1]."\r".'utf-8');
	rcms_showAdminMessage ($path . $langfile.' write!<br/>');}
	elseif (is_file($path . $langfile)&& is_file(ADMIN_PATH.'libs/utf_maps/'.$map.'.MAP')){
				$data = file_get_contents($path . $langfile);
				$utfConverter = new utf8($map);
				$data = $utfConverter->strToUtf8($data);
				file_write_contents ($path . $langfile,$data);
				rcms_showAdminMessage ($path . $langfile.' write!<br/>');
		} else rcms_showAdminMessage($path . $langfile . ' <font color="red">'.__('Error occurred').'</font>');
	}
}
    $steptime = explode(" ",microtime());
    $steptime = $steptime[1];
	rcms_showAdminMessage ('Step ' . $step . __(' done in ').number_format($steptime-$time).' secs');
	$totaltime += $steptime;
	$time = $steptime;
}

//step : convert config
if (!empty($_POST['config'])){
$step++;
rcms_showAdminMessage ('<b>' . __('Step '). $step .': convert config </b>');
convertDir(array(CONFIG_PATH));
    $steptime = explode(" ",microtime());
    $steptime = $steptime[1];
	rcms_showAdminMessage ('Step ' . $step . __(' done in ').number_format($steptime-$time).' secs');
	$totaltime += $steptime;
	$time = $steptime;
}

//step : convert content
if (!empty($_POST['content'])){
$step++;
rcms_showAdminMessage ('<b>' . __('Step '). $step .': convert content</b>');
convertDir(array(DATA_PATH));
    $steptime = explode(" ",microtime());
    $steptime = $steptime[1];
	rcms_showAdminMessage ('Step ' . $step . __(' done in ') . number_format($steptime-$time) . ' secs');
	$totaltime += $steptime;
	$time = $steptime;
}
rcms_showAdminMessage ('<b>' . __('Execution time: ') . number_format($totaltime/1000000000) . ' s</b>');
rcms_showAdminMessage ('<b>' . __('Memory peak usage: ') . number_format(memory_get_peak_usage()/(1024*1024),2)."MB</b>");
}

////////////////////////////////////////////////////////////////////////////////
// Interface generation                                                       //
////////////////////////////////////////////////////////////////////////////////

$frm =new InputForm ('', 'post', __('Submit'));
$frm->addbreak(__('Converter to UTF-8') );
$frm->addrow(__('Backup data'), $frm->checkbox('backupit', '1', '', true));
$frm->addrow(__('Pack file with gzip (uncheck if you experience problems)'), $frm->checkbox('gzip', '1', '', true));
$frm->addrow(__('Enable all').__(' languages'), $frm->checkbox('langs', '1', '', '1', 4));
$frm->addrow(__('Enable all').__(' config'), $frm->checkbox('config', '1', '', '1', 4));
$frm->addrow(__('Enable all').__(' content'), $frm->checkbox('content', '1', '', '1', 4));
$frm->hidden('start', '2');
$frm->show();
?>